<TeXmacs|1.0.0.17>

<style|tmdoc>

<\body>
  <expand|tmdoc-title|Supporting your system inside <apply|TeXmacs>>

  Assume that you have successfully written a first interface with
  <apply|TeXmacs> as explained in the previous section. Then it is time now
  to include support for your system in the standard <apply|TeXmacs>
  distribution, after which further improvements can be made.

  The easiest way to get your system supported is to send us a copy of your
  software with the new interface with the request to incorporate the
  necessary support into <apply|TeXmacs>. By default, we will call your
  program using the <verbatim|--texmacs> option; if this is not appropriate,
  then you should say so.

  You may also write the support for your system yourself. Assuming that the
  name of your system is <verbatim|yourcas>, you should follow the following
  steps:

  <\enumerate>
    <item>Create a file of the form <verbatim|yourcas.scm> in the directory
    <verbatim|$TEXMACS_PATH/progs/cas>. You should load this file on startup,
    by editing the global <verbatim|init-texmacs.scm> (or your personal
    <verbatim|my-init-texmacs.scm>) initialization file.

    <item>Include a line of the form\ 

    <\verbatim>
      \ \ \ \ (connection-declare "yourcas" "shell-cmd")
    </verbatim>

    in <verbatim|yourcas.scm>, where <verbatim|shell-cmd> is the shell
    command to launch your system (including special command line options
    which allow your program to recognize that it was called from inside
    <apply|TeXmacs>). Usually <verbatim|shell-cmd> is <verbatim|yourcas
    --texmacs>.

    <item>Add a line of the form\ 

    <\verbatim>
      \ \ \ \ (connection-format "yourcas" "input-format" "output-format")
    </verbatim>

    to <verbatim|yourcas.scm> if your input and output is not merely verbatim
    text. Usually, the <verbatim|input-format> is <verbatim|verbatim> and the
    <verbatim|output-format> is <verbatim|generic>. Other avilable formats
    are <verbatim|scheme>, <verbatim|latex>, <verbatim|html> and
    <verbatim|ps>.

    <item>Add a command like\ 

    <\verbatim>
      \ \ \ \ (set! session-menu (menu-merge session-menu<format|next line>
      \ \ \ \ \ '(("yourcas" (make-session "yourcas")))))
    </verbatim>

    to <verbatim|yourcas.scm>, in order to be able to start a
    <apply|TeXmacs>-session from the <apply|menu|Insert|Session> menu, in
    which you can evaluate expressions of your language. You may also
    redefine the keyboard for such sessions.

    <item>Create a style file <verbatim|yourcas.ts> in
    <verbatim|$TEXMACS_PATH/packages/session> environments `yourcas-session',
    `yourcas-input' and `output-yourcas'. Alternatively, you may put this
    file in <verbatim|$TEXMACS_HOME_PATH/packages>.

    <item>If everything works well, and you wish to make it possible for
    others to use your system inside the official <apply|TeXmacs>
    distribution, then contact me at <verbatim|vdhoeven@texmacs.org>.
  </enumerate>

  <apply|tmdoc-copyright|1998--2002|Joris van der Hoeven>

  <expand|tmdoc-license|Permission is granted to copy, distribute and/or
  modify this document under the terms of the GNU Free Documentation License,
  Version 1.1 or any later version published by the Free Software Foundation;
  with no Invariant Sections, with no Front-Cover Texts, and with no
  Back-Cover Texts. A copy of the license is included in the section entitled
  "GNU Free Documentation License".>
</body>

<\initial>
  <\collection>
    <associate|paragraph width|150mm>
    <associate|odd page margin|30mm>
    <associate|shrinking factor|4>
    <associate|page right margin|30mm>
    <associate|page top margin|30mm>
    <associate|reduction page right margin|25mm>
    <associate|page type|a4>
    <associate|reduction page bottom margin|15mm>
    <associate|even page margin|30mm>
    <associate|reduction page left margin|25mm>
    <associate|page bottom margin|30mm>
    <associate|reduction page top margin|15mm>
    <associate|language|english>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|idx-1|<tuple|<uninit>|?>>
    <associate|toc-1|<tuple|<uninit>|?>>
    <associate|idx-2|<tuple|<uninit>|?>>
    <associate|toc-2|<tuple|<uninit>|?>>
  </collection>
</references>
