
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : build-glue-basic.scm
;; DESCRIPTION : Building basic glue
;; COPYRIGHT   : (C) 1999  Joris van der Hoeven
;;
;; This software falls under the GNU general public licence and comes WITHOUT
;; ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(output-copyright "build-glue-basic.scm")

(build
  ""
  "initialize_glue_basic"

  (tree->object tree_to_scheme_tree (scheme_tree tree))
  (object->tree scheme_tree_to_tree (tree scheme_tree))
  (tree->string coerce_tree_string (string tree))
  (tree-get-label get_tree_label (tree_label tree))
  (string->tree coerce_string_tree (tree string))
  (tree tree (texmacs_tree tree_label texmacs_tree texmacs_tree texmacs_tree))
  (tree-atomic? is_atomic (bool texmacs_tree))
  (tree-compound? is_compound (bool texmacs_tree))
  (tree-arity N (int texmacs_tree))
  (tree-ref tree_ref (texmacs_tree texmacs_tree int))
  (tree-set! tree_set (void texmacs_tree int texmacs_tree))
  (subtree subtree (texmacs_tree texmacs_tree path))
  (tree->verbatim tree_to_verbatim (string tree))
  (cursor-start start (path texmacs_tree path))
  (cursor-end end (path texmacs_tree path))
  (use-ec-fonts? use_ec_fonts (bool))
  (file-exists? file_exists (bool string string))
  (tex-file-exists? tex_file_exists (bool string))
  (decode-file-name decode_file_name (string string))
  (unique-file-name get_unique_file_name (string string string))
  (relative-file-name get_relative_file_name (string string string))
  (newer? is_newer (bool string string))
  (load-file-as-tree load_file (texmacs_tree string string string))
  (upcase-first upcase_first (string string))
  (locase-first locase_first (string string))
  (upcase-all upcase_all (string string))
  (locase-all locase_all (string string))

  (package-declare package_declare (void string string string string))
  (package-format package_format (void string string string))
  (connection-declare connection_declare (void string string))
  (connection-format connection_format (void string string string))
  (connection-filter-tree-in connection_filter_tree_in (void string string))
  (connection-filter-in connection_filter_string_in (void string string))
  (connection-filter-out connection_filter_string_out (void string string))
  (connection-filter-tree-out connection_filter_tree_out (void string string))
  (connection-exec connection_exec (void string string string))
  (connection-eval connection_eval (texmacs_tree string string texmacs_tree))

  (eval-system eval_system (string string))
  (get-locale-language get_locale_language (string))
  (menu-merge menu_merge (scheme_tree scheme_tree scheme_tree))

  (path-inf? path_inf (bool path path))
  (path-inf-eq? path_inf_eq (bool path path))
  (path-less? path_less (bool path path))
  (path-less-eq? path_less_eq (bool path path))

  (widget-hlist horizontal_list (widget array_widget))
  (widget-named-hlist horizontal_list (widget array_widget array_string))
  (widget-vlist vertical_list (widget array_widget))
  (widget-named-vlist vertical_list (widget array_widget array_string))
  (widget-vmenu vertical_menu (widget array_widget))
  (widget-tile tile (widget array_widget int))
  (widget-named-tile tile (widget array_widget int array_string))
  (widget-harray horizontal_array (widget array_widget int))
  (widget-named-harray horizontal_array (widget array_widget array_string int))
  (widget-switch switch_widget (widget array_widget array_string))
  (widget-switch-init switch_widget (widget array_widget array_string int))
  (widget-optional optional_widget (widget widget))
  (widget-optional-init optional_widget (widget widget bool))
  (widget-glue glue_widget (widget bool bool int int))
  (widget-separator separator_widget (widget int int bool))
  (widget-text text_widget (widget string bool string))
  (widget-xpm xpm_widget (widget string bool))
  (widget-menu-text menu_text_widget (widget string int string bool))
  (widget-command-button-1 command_button (widget widget command bool))
  (widget-command-button-2 command_button (widget widget widget command))
  (widget-command-button-3 command_button
			   (widget widget widget widget command bool bool))
  (widget-pulldown-button pulldown_button (widget widget widget))
  (widget-pullright-button pullright_button (widget widget widget))
  ;;(widget-popup popup_widget (widget widget gravity))
  ;;(widget-canvas canvas_widget (widget widget gravity))
  ;;(widget-text-input input_text_widget (widget command))
  ;;(widget-file-chooser file_chooser_widget (widget command string string))
  (widget-balloon balloon_widget (widget widget widget))
  (widget-pulldown-button-lazy pulldown_button (widget widget make_widget))
  (widget-pullright-button-lazy pullright_button (widget widget make_widget))
  (widget-wait wait_widget (widget int int string))
  (widget-box box_widget (widget scheme_tree string int bool bool))
  (widget-promise make_scheme_make_widget (make_widget scheme_tree)))
